/*
** rel.c for elfsh
** 
** Started on  Fri Nov  2 15:19:19 2001 mayhem
** Last update Thu Mar 13 01:37:56 2003 mayhem
*/
#include "elfsh.h"




/* Display relocation entries */
int		cmd_rel()
{
  elfshsect_t	*sect;
  Elf32_Rel	*rel;
  regex_t	*tmp;
  char		*type;
  char		*typeshort;
  Elf32_Sym	*sym;
  char		*name;
  char		*name_dyn;
  u_int		index;
  u_int		index2;
  u_int		typenum;
  int		offset;
  int		offset_dyn;
  char		off[30];
  char		buff[256];

  /* Choose between global or local regx */
  CHOOSE_REGX(tmp);
  printf(" [RELOCATION TABLES]\n [Object %s]\n\n", world.current->name);
  off[0] = 0;

  /* We need to iterate as much as there is .rel* sections */
  sect = elfsh_get_reloc(world.current, 0, NULL);
  for (index2 = 0; sect; index2++)
    {
      
      printf(" {Section %s} \n", elfsh_get_section_name(world.current, sect));
      
      /* Reverse the associated symbol for each entry of the section */
      for (index = 0, rel = sect->data; index < sect->nbr; index++)
	{
	  
	  sym = elfsh_get_symbol_from_reloc(world.current, rel + index);
	  name = elfsh_reverse_symbol(world.current, sym->st_value, &offset);
	  name_dyn = elfsh_reverse_dynsymbol(world.current, sym->st_value, 
					     &offset_dyn);
	  if (name_dyn && offset_dyn < offset)
	    {
	      offset = offset_dyn;
	      name = name_dyn;
	    }

	  /* Fill the resolve buffer */
	  if (offset)
	    snprintf(off, sizeof(off), " %c %05u", 
		     (offset < 0 ? '-' : '+'), 
		     (offset > 0 ? offset : offset - offset - offset));

	  typenum   = elfsh_get_reltype(rel + index);
	  type      = (char *) (typenum > ELFSH_RELOC_MAX ? NULL : 
				elfsh_rel_type[typenum].desc);
	  typeshort = (char *) (typenum > ELFSH_RELOC_MAX ? NULL : 
				elfsh_rel_type[typenum].name);
	
	  /* Output is different depending on the quiet flag */
	  if (!world.state.vm_quiet)
	    snprintf(buff, sizeof(buff), 
		     " [%03u] %-15s %-10p sym[%03u] = [ %30s%s %-10p ] => %s",
		     index, typeshort, 
		     (void *) elfsh_get_reloffset(rel + index), 
		     elfsh_get_relsym(rel + index),
		     (name ? name : "<?>"), 
		     (name && offset ? off : "        "), 
		     (void *) sym->st_value, type);
	  else
	    snprintf(buff, sizeof(buff), 
		     " [%03u] %-15s %-10p sym[%03u] = [ %15s%s %-10p ]",
		     index, typeshort, 
		     (void *) elfsh_get_reloffset(rel + index), 
		     elfsh_get_relsym(rel + index),
		     (name ? name : "<?>"), 
		     (name && offset ? off : "        "), 
		     (void *) sym->st_value);

	  /* Print it if it matchs the regex */
	  if (!tmp || (tmp && name && !regexec(tmp, buff, 0, 0, 0)))
	    puts(buff);

	}

      sect = elfsh_get_reloc(world.current, index2 + 1, NULL);
      puts("");
    }

  puts("");
  return (0);
}

