/*
** comment.c for elfsh in 
** 
** Made by mayhem
** Login   <mayhem@devhell.org>
** 
** Started on  Sun Dec  1 09:22:45 2002 mayhem
** Last update Mon Mar 17 04:39:35 2003 mayhem
*/
#include "libelfsh.h"


/* Get comment section */
elfshsect_t		*elfsh_get_comments(elfshobj_t *file)
{
  elfshsect_t		*new;
  u_int			size;

  if (!file)
    return (NULL);
  new = elfsh_get_section_by_name(file, ELFSH_SECTION_NAME_COMMENT, NULL, NULL, &size);
  if (!new)
    return (NULL);
  new->nbr = size;
  if (!new->data)
    {
      new->data = elfsh_load_section(file, new->shdr);
      if (!new->data)
	return (NULL);
    }
  file->secthash[ELFSH_SECTION_COMMENT] = new;
  return (new);
}


/* Get an entry from .comment */
char			*elfsh_get_comments_entry(elfshobj_t *file, u_int range)
{
  int			index;
  int			act;
  char			*data;

  if (!file->secthash[ELFSH_SECTION_COMMENT] && !elfsh_get_comments(file))
    return (NULL);
  index = act = 0;
  data = file->secthash[ELFSH_SECTION_COMMENT]->data;
  while (data[index] == 0x00)
    index++;
  while (act != range && 
	 index < file->secthash[ELFSH_SECTION_COMMENT]->shdr->sh_size)
    if (data[index] == 0x00)
      {
	act++;
	while (data[index] == 0x00)
	  index++;
      }
    else
      index++;
  if (index < file->secthash[ELFSH_SECTION_COMMENT]->shdr->sh_size)
    return (data + index);
  return (NULL);
}
