/*
**
** Current libelfsh API (0.5b4) on Sun Feb 16 04:17:57 2003
**
*/


/* dynamic.c */
Elf32_Dyn	*elfsh_get_dynamic(elfshobj_t *file, int *num);
Elf32_Dyn	*elfsh_get_dynamic_entry_by_type(elfshobj_t *file, char type);
char		*elfsh_get_dynentry_info(elfshobj_t *file, Elf32_Dyn *d);
Elf32_Sword	elfsh_get_dynentry_type(Elf32_Dyn *d);
int		elfsh_set_dynentry_type(Elf32_Dyn *d, Elf32_Sword tag);
Elf32_Word	elfsh_get_dynentry_val(Elf32_Dyn *d);
int		elfsh_set_dynentry_val(Elf32_Dyn *d, Elf32_Word val);
Elf32_Dyn	*elfsh_get_dynamic_entry_by_index(Elf32_Dyn *dynamic, u_int index);

/* symbol.c */
Elf32_Sym	*elfsh_get_symbol_from_reloc(elfshobj_t *file, Elf32_Rel *s);
Elf32_Sym	*elfsh_get_symbol_by_name(elfshobj_t *file, char *name);
char		*elfsh_reverse_symbol(elfshobj_t *file, u_int sym_value, int *offset);
char		*elfsh_get_symbol_name(elfshobj_t *file, Elf32_Sym *s);
void		*elfsh_get_symtab(elfshobj_t *file, int *num);
Elf32_Sym	*elfsh_get_symbol_by_value(elfshobj_t *file, u_int vaddr, int *off, int mode);

/* dynsym.c */
Elf32_Sym	*elfsh_get_dynsymbol_by_name(elfshobj_t *file, char *name);
void		*elfsh_get_dynsymtab(elfshobj_t *file, int *num);
char		*elfsh_reverse_dynsymbol(elfshobj_t *file, u_int sym_value, int *offset);
char		*elfsh_get_dynsymbol_name(elfshobj_t *file, Elf32_Sym *s);

/* sym_common.c */
Elf32_Sym	elfsh_create_symbol(int value, int size, int type, int binding, int visibility);
Elf32_Sym	*elfsh_copy_symtab(void *addr, int size);
Elf32_Sym	*elfsh_merge_symtabs(Elf32_Sym *one, Elf32_Sym *two, int size_one, int size_two);
Elf32_Sym	*elfsh_get_sym_by_value(Elf32_Sym *sym, int num, u_int vaddr, int *off, int mode);
int		elfsh_insert_symbol(elfshsect_t *sect, Elf32_Sym *sym, char *name);
int		elfsh_sort_symtab(Elf32_Sym *symtab, int size, int type);
Elf32_Word      elfsh_get_symbol_size(Elf32_Sym *s);
Elf32_Addr      elfsh_get_symbol_value(Elf32_Sym *s);
u_char		elfsh_get_symbol_bind(Elf32_Sym *s);
u_char		elfsh_get_symbol_type(Elf32_Sym *s);
u_char		elfsh_get_symbol_visibility(Elf32_Sym *s);
int		elfsh_set_symbol_size(Elf32_Sym *s, Elf32_Word size);
int		elfsh_set_symbol_value(Elf32_Sym *s, Elf32_Addr value);
u_char		elfsh_set_symbol_bind(Elf32_Sym *s, char opt);
u_char		elfsh_set_symbol_type(Elf32_Sym *s, char type);
u_int		elfsh_set_symbol_visibility(Elf32_Sym *s, char vis);
Elf32_Sym	*elfsh_get_symbol_by_index(Elf32_Sym *symtab, u_int index);

/* obj.c */
elfshobj_t	*elfsh_load_obj(char *name);
void		elfsh_unload_obj(elfshobj_t *file);

/* elf.c */
int		elfsh_load_hdr(elfshobj_t *file);
void		*elfsh_get_hdr(elfshobj_t *file);
Elf32_Off       elfsh_get_shtoff(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_shtnbr(Elf32_Ehdr *e);
Elf32_Off       elfsh_get_phtoff(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_phtnbr(Elf32_Ehdr *e);
Elf32_Addr      elfsh_get_entrypoint(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_arch(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_objtype(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_shstrtab_index(Elf32_Ehdr *e);
Elf32_Word      elfsh_get_version(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_ehsize(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_phentsize(Elf32_Ehdr *e);
Elf32_Half      elfsh_get_shentsize(Elf32_Ehdr *e);
int             elfsh_set_shtoff(Elf32_Ehdr *e, Elf32_Off off);
int             elfsh_set_shtnbr(Elf32_Ehdr *e, Elf32_Half num);
int             elfsh_set_phtoff(Elf32_Ehdr *e, Elf32_Off num);
int		elfsh_set_phtnbr(Elf32_Ehdr *e, Elf32_Half num);
int             elfsh_set_entrypoint(Elf32_Ehdr *e, Elf32_Addr addr);
u_int		elfsh_set_arch(Elf32_Ehdr *e, Elf32_Half val);
u_int		elfsh_set_objtype(Elf32_Ehdr *e, Elf32_Half val);
u_int		elfsh_set_shstrtab_index(Elf32_Ehdr *e, Elf32_Half val);
u_int		elfsh_set_version(Elf32_Ehdr *e, Elf32_Word val);
u_int		elfsh_set_ehsize(Elf32_Ehdr *e, Elf32_Half val);
u_int		elfsh_set_phentsize(Elf32_Ehdr *e, Elf32_Half val);
u_int		elfsh_set_shentsize(Elf32_Ehdr *e, Elf32_Half val);
int		elfsh_get_encoding(Elf32_Ehdr *hdr);
int		elfsh_set_encoding(Elf32_Ehdr *hdr, u_char type);
int		elfsh_set_flags(Elf32_Ehdr *hdr, Elf32_Word flags);
Elf32_Word	elfsh_get_flags(Elf32_Ehdr *hdr);

/* pax.c */
int		elfsh_set_paxflags(Elf32_Ehdr *hdr, Elf32_Word flags);
Elf32_Word	elfsh_get_paxflags(Elf32_Ehdr *hdr);
char            elfsh_set_pax_pageexec(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_pageexec(Elf32_Ehdr *hdr);
char            elfsh_set_pax_emultramp(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_emultramp(Elf32_Ehdr *hdr);
char            elfsh_set_pax_mprotect(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_mprotect(Elf32_Ehdr *hdr);
char            elfsh_set_pax_randmmap(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_randmmap(Elf32_Ehdr *hdr);
char            elfsh_set_pax_randexec(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_randexec(Elf32_Ehdr *hdr);
char            elfsh_set_pax_segmexec(Elf32_Ehdr *hdr, u_short off);
char            elfsh_get_pax_segmexec(Elf32_Ehdr *hdr);


/* stab.c */
void		*elfsh_get_stab(elfshobj_t *file, int *num);
void		*elfsh_get_stab_offset(elfshstabent_t *s);
char		*elfsh_get_stab_name(elfshobj_t *file, elfshstabent_t *s);
u_int		elfsh_get_stab_type(elfshstabent_t *s);


/* sht.c */
Elf32_Shdr      *elfsh_get_shtentry_from_sym(elfshobj_t *file, Elf32_Sym *sym);
void		*elfsh_get_sht(elfshobj_t *file, int *num);
char		*elfsh_get_section_name(elfshobj_t *file, Elf32_Shdr *s);
int		elfsh_load_sht(elfshobj_t *file);
Elf32_Sym	*elfsh_get_sym_from_shtentry(elfshobj_t *file, Elf32_Shdr *hdr);
Elf32_Word      elfsh_get_section_info(Elf32_Shdr *s);
Elf32_Word      elfsh_get_section_entsize(Elf32_Shdr *s);
Elf32_Word      elfsh_get_section_link(Elf32_Shdr *s);
Elf32_Off       elfsh_get_section_foffset(Elf32_Shdr *s);
Elf32_Addr      elfsh_get_section_addr(Elf32_Shdr *s);
Elf32_Word      elfsh_get_section_align(Elf32_Shdr *s);
Elf32_Word      elfsh_get_section_size(Elf32_Shdr *s);
Elf32_Word      elfsh_get_section_type(Elf32_Shdr *s);
int             elfsh_set_section_info(Elf32_Shdr *s, Elf32_Word info);
int             elfsh_set_section_entsize(Elf32_Shdr *s, Elf32_Word entsize);
int             elfsh_set_section_link(Elf32_Shdr *s, Elf32_Word link);
int		elfsh_set_section_foffset(Elf32_Shdr *s, Elf32_Off offset);
int		elfsh_set_section_addr(Elf32_Shdr *s, Elf32_Addr addr);
int		elfsh_set_section_align(Elf32_Shdr *s, Elf32_Word align);
int		elfsh_set_section_size(Elf32_Shdr *s, Elf32_Word size);
int		elfsh_set_section_type(Elf32_Shdr *s, Elf32_Word type);
Elf32_Shdr	*elfsh_get_sht_entry_by_index(Elf32_Shdr *s, u_int index);

char		elfsh_get_section_execflag(Elf32_Shdr *s);
char		elfsh_get_section_writableflag(Elf32_Shdr *s);
char		elfsh_get_section_allocflag(Elf32_Shdr *s);
char		elfsh_get_section_mergeableflag(Elf32_Shdr *s);
char		elfsh_get_section_strflag(Elf32_Shdr *s);
char		elfsh_get_section_linkflag(Elf32_Shdr *s);
char		elfsh_get_section_orderflag(Elf32_Shdr *s);
char		elfsh_set_section_execflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_writableflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_allocflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_mergeableflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_strflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_linkflag(Elf32_Shdr *s, char f);
char		elfsh_set_section_orderflag(Elf32_Shdr *s, char f);

int		elfsh_insert_section_header(elfshobj_t *file, Elf32_Shdr hdr, u_int range, char *name);
void		elfsh_remove_sht(elfshobj_t *file);
Elf32_Shdr	elfsh_create_section_header(Elf32_Word name, Elf32_Word type, Elf32_Word flags,
					    Elf32_Addr addr, Elf32_Off offset, Elf32_Word size,
					    Elf32_Word link, Elf32_Word info, Elf32_Word align,
					    Elf32_Word entsize);



/* pht.c */
void		*elfsh_get_pht(elfshobj_t *file, int *num);
Elf32_Phdr	*elfsh_get_segment_by_type(elfshobj_t *file, int type, int range);
Elf32_Phdr	*elfsh_get_parent_segment(elfshobj_t *file, elfshsect_t *new);
int		elfsh_load_pht(elfshobj_t *file);
int		elfsh_segment_is_writable(Elf32_Phdr *p);
int		elfsh_segment_is_readable(Elf32_Phdr *p);
int		elfsh_segment_is_executable(Elf32_Phdr *p);
int		elfsh_segment_is_parent(elfshsect_t *new, Elf32_Phdr *p);
int		elfsh_set_segment_flags(Elf32_Phdr *p, Elf32_Word flags);
int		elfsh_set_segment_align(Elf32_Phdr *p, Elf32_Word align);
int		elfsh_set_segment_memsz(Elf32_Phdr *p, Elf32_Word memsz);
int		elfsh_set_segment_filesz(Elf32_Phdr *p, Elf32_Word filesz);
int		elfsh_set_segment_paddr(Elf32_Phdr *p, Elf32_Addr paddr);
int		elfsh_set_segment_vaddr(Elf32_Phdr *p, Elf32_Addr vaddr);
Elf32_Word      elfsh_get_segment_flags(Elf32_Phdr *p);
Elf32_Word      elfsh_get_segment_align(Elf32_Phdr *p);
Elf32_Word      elfsh_get_segment_memsz(Elf32_Phdr *p);
Elf32_Word      elfsh_get_segment_filesz(Elf32_Phdr *p);
Elf32_Addr      elfsh_get_segment_paddr(Elf32_Phdr *p);
Elf32_Addr      elfsh_get_segment_vaddr(Elf32_Phdr *p);
Elf32_Word	elfsh_get_segment_type(Elf32_Phdr *p);
int		elfsh_set_segment_type(Elf32_Phdr *p, Elf32_Word type);
Elf32_Off	elfsh_get_segment_offset(Elf32_Phdr *p);
int		elfsh_set_segment_offset(Elf32_Phdr *p, Elf32_Off offset);
Elf32_Phdr	*elfsh_get_pht_entry_by_index(Elf32_Phdr *pht, u_int index);


/* hash.c */
void		*elfsh_get_hashtable(elfshobj_t *file);
int		elfsh_get_symbol_hash(char *sym_name);
int		elfsh_get_dynsymbol_by_hash(elfshobj_t *file, char *sym_name);

/* got.c */
void		*elfsh_get_got(elfshobj_t *file, int *num);
u_int		elfsh_set_got_entry(u_int *got, u_int vaddr);
u_int		*elfsh_get_got_entry_by_index(u_int *got, u_int index);
u_int		elfsh_get_got_entry(u_int *got);
int		elfsh_set_got_entry_by_index(elfshobj_t *file, int index, int new_addr);
int		elfsh_set_got_entry_by_name(elfshobj_t *file, char *name, int new_addr);

/* dtors.c */
void		*elfsh_get_dtors(elfshobj_t *file, int *num);
int		elfsh_set_dtors_entry_by_index(elfshobj_t *file, int index, int new_addr);
int		elfsh_set_dtors_entry_by_name(elfshobj_t *file, char *name, int new_addr);
u_int		*elfsh_get_dtors_entry_by_index(u_int *dtors, u_int index);
u_int		elfsh_set_dtors_entry(u_int *dtors, u_int vaddr);
u_int		elfsh_get_dtors_entry(u_int *dtors);

/* ctors.c */
void		*elfsh_get_ctors(elfshobj_t *file, int *num);
int		elfsh_set_ctors_entry_by_name(elfshobj_t *file, char *name, int new_addr);
int		elfsh_set_ctors_entry_by_index(elfshobj_t *file, int index, int new_addr);
u_int		*elfsh_get_ctors_entry_by_index(u_int *ctors, u_int index);
u_int		elfsh_set_ctors_entry(u_int *ctors, u_int vaddr);
u_int		elfsh_get_ctors_entry(u_int *ctors);


/* section.c */
elfshsect_t	*elfsh_get_section_by_type(elfshobj_t *, u_int, int *, int *, int *, int);
elfshsect_t	*elfsh_get_section_by_index(elfshobj_t *, int, int *, int *);
elfshsect_t	*elfsh_get_section_by_name(elfshobj_t *, char *, int *, int *, int *);
elfshsect_t	*elfsh_get_parent_section(elfshobj_t *file, u_int value, int *offset);
elfshsect_t	*elfsh_get_parent_section_by_foffset(elfshobj_t *file, u_int value, int *offset);
elfshsect_t	*elfsh_create_section(char *name);
void		*elfsh_load_section(elfshobj_t *file, Elf32_Shdr *shdr);
void		*elfsh_get_anonymous_section(elfshobj_t *file, elfshsect_t *sect);
int		elfsh_add_section(elfshobj_t *file, elfshsect_t *sect, u_int index, void *data, int shift);
int		elfsh_append_data_to_section(elfshsect_t *sect, void *input, int len);
int		elfsh_insert_unmapped_section(elfshobj_t *file, elfshsect_t *sect, Elf32_Shdr hdr, void *data);
int		elfsh_insert_mapped_section(elfshobj_t *file, elfshsect_t *sect, Elf32_Shdr hdr, void *data, int mode);
int		elfsh_insert_code_section(elfshobj_t *file, elfshsect_t *sect, Elf32_Shdr hdr, void *data);
elfshsect_t	*elfsh_get_section_list(elfshobj_t *file);

/* rel.c */
elfshsect_t	*elfsh_get_reloc(elfshobj_t *file, u_int range, u_int *num);
void		elfsh_free_reloc_list(elfshobj_t *file);
u_int		elfsh_set_reltype(Elf32_Rel *r, Elf32_Word type);
u_int		elfsh_set_relsym(Elf32_Rel *r, Elf32_Word sym);
int             elfsh_set_reloffset(Elf32_Rel *r, Elf32_Addr off);
u_int		elfsh_get_reltype(Elf32_Rel *r);
u_int		elfsh_get_relsym(Elf32_Rel *r);
Elf32_Addr      elfsh_get_reloffset(Elf32_Rel *r);
Elf32_Rel	*elfsh_get_relent_by_index(Elf32_Rel *table, u_int index);

/* interp.c */
char		*elfsh_get_interp(elfshobj_t *file);
int             elfsh_write_interp(elfshobj_t *file, char *interp);

/* notes */
elfshsect_t	*elfsh_get_notes(elfshobj_t *file, u_int range, char *name);
void		elfsh_free_notes_list(elfshobj_t *file);

/* functions.c */
elfshblock_t	*elfsh_get_function_by_addr(elfshobj_t *file, int addr);
elfshblock_t    *elfsh_get_function_by_name(elfshobj_t *file, char *name);
int		elfsh_get_function_len(elfshblock_t *func);
int		elfsh_get_function_addr(elfshblock_t *func);
int		elfsh_insert_function(elfshsect_t *sct, elfshblock_t *fct, int range);
int		elfsh_scan_functions(elfshobj_t *file);
int		elfsh_sort_functions(elfshobj_t *file);

/* plt.c */
elfshsect_t	*elfsh_get_plt(elfshobj_t *file, int *num);
int		elfsh_is_pltentry(elfshobj_t *file, Elf32_Sym *sym);
int		elfsh_is_plt(elfshobj_t *file, Elf32_Shdr *s);

/* raw.c */
int		elfsh_raw_write(elfshobj_t *file, u_int dst, void *src, int len);
int		elfsh_raw_read(elfshobj_t *file, u_int dst, void *src, int len);
int		elfsh_get_foffset_from_vaddr(elfshobj_t *file, u_int vaddr);
int		elfsh_get_vaddr_from_foffset(elfshobj_t *file, u_int foffset);

/* map.c */
elfshobj_t	*elfsh_map_obj(char *name);
int		elfsh_save_obj(elfshobj_t *file, char *name);

/* strtab.c */
int		elfsh_insert_in_strtab(elfshobj_t *file, char *name);
int		elfsh_insert_in_shstrtab(elfshobj_t *file, char *name);

/* error.c */
void		elfsh_error();

/* fixup.c */
elfshsect_t	*elfsh_rebuild_strtab(elfshobj_t *file);
elfshsect_t	*elfsh_fixup_symtab(elfshobj_t *file, int *strindex);
int		elfsh_fixup_bss(elfshobj_t *file);


/* sht_rebuild.c */
int		elfsh_rebuild_sht(elfshobj_t *file);

/* comment.c */
elfshsect_t	*elfsh_get_comments(elfshobj_t *file);
char		*elfsh_get_comments_entry(elfshobj_t *file, u_int range);

/* hijack.c */
int		elfsh_hijack_function_by_name(elfshobj_t *file,
					uint32_t type,
                                        char *name, Elf32_Addr addr);

#endif /* __LIBELFSH_H_ */








