/*
** modgraph.c for elfsh
**
** THIS CODE IS WORK IN PROGRESS
**
** The instruction type checking should be made 
** easier by libasm, this is waiting for libasm update .
** 
** Started on  Fri Mar  7 07:18:03 2003 mayhem
** Last update Mon Mar 17 04:46:14 2003 mayhem
*/
#include "elfsh.h"


#define	CMD_GRAPH	"graph"


/* Add a link entry to the graph */
void		vm_write_graphent(elfshobj_t *file, 
				  int fd, 
				  elfshblock_t *src, 
				  elfshblock_t *dst)
{
  char		buf[BUFSIZ];
  char		*src_name;
  char		*dst_name;

  src_name = elfsh_get_symbol_name(file, src->sym);
  dst_name = elfsh_get_symbol_name(file, dst->sym);
  if (src_name == NULL)
    src_name = ELFSH_NULL_STRING;
  if (dst_name == NULL)
    dst_name = ELFSH_NULL_STRING;
  snprintf(buf, sizeof(buf), "%s -> %s [color=\"0.650 0.700 0.700\"];\n",
	   src_name, dst_name);
  write(fd, buf, strlen(buf));
}


/* Graph the binary */
int		cmd_graph()
{
  asm_instr	instr;
  elfshblock_t	*blk;
  elfshblock_t	*dst;
  elfshsect_t	*sect;
  int		fd;
  char		buf[BUFSIZ];
  u_int		idx;
  u_int		ret;
  u_int		vaddr;
  char		*name;

  XOPEN(fd, world.args.param[0], O_RDWR | O_CREAT, 0644, -1);
  sprintf(buf, "digraph prof {\n size=\"6,4\"; ratio = fill; node [style=filled];\n");
  write(fd, buf, strlen(buf));

  /* For each executable section, get the block list */
  for (sect = world.current->sectlist; sect; sect = sect->next)
    if (elfsh_get_section_execflag(sect->shdr))
      {
	
#if __DEBUG_BLOCKS__
	elfsh_print_blocks(sect);
#endif

	/* Iterate on the block list */
	for (blk = sect->altdata; blk != NULL; blk = blk->next)
	  {
	    
	    name = elfsh_get_symbol_name(world.current, blk->sym);
	    if (name == NULL)
	      name = ELFSH_NULL_STRING;
	    
	    /* Write the block as a node */
	    snprintf(buf, sizeof(buf), "%s [color=\"0.650 0.200 1.000\"];\n", 
		     name);
	    write(fd, buf, strlen(buf));
	    
	    /* For each link, write a link */
	    if (!world.state.vm_quiet)
	      printf(" [-] Analyzing block %s [size = %08u] \n", 
		     name, blk->len);
	    
	    /* Iterate on each instruction of the block */
	    for (idx = 0; idx < blk->len; idx += ret)
	      {
		
		ret = asm_read_instr(&instr, 
				     blk->section->data + blk->offset + idx,
				     blk->len - idx + 10, &world.proc);
		ret = asm_instr_len(&instr);
		
		/* For all branch instruction */
		switch (instr.instr)
		  {
		    
		    /* Relative branch instructions */
		  case 0xEB:
		  case 0xE8:
		    vaddr = sect->shdr->sh_addr + blk->offset + idx + instr.op1->imm;
		    dst = elfsh_get_block_by_addr(world.current, vaddr);
		    vm_write_graphent(world.current, fd, blk, dst);
		    break;

		    /* Default action is doing nothing */
		  default:
		    break;
		  }
	      }
	  }
      }
  
  write(fd, "}\n", 2);
  XCLOSE(fd, -1);
  printf(" [*] Graph description dumped in %s \n\n", world.args.param[0]);
  return (0);
}


void	elfsh_init()
{
  puts(" [*] ELFsh modgraph loaded \n");
  vm_addcmd(CMD_GRAPH, cmd_graph, vm_getoption, 1);
}


void	elfsh_fini()
{
  vm_delcmd(CMD_GRAPH);
  puts(" [*] ELFsh modgraph unloaded \n");
}

